package  
{
	
	import flash.filters.BitmapFilterQuality;
	import net.flashpunk.Entity;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	import net.flashpunk.tweens.motion.QuadMotion;
	import net.flashpunk.Sfx;
	
	/**
	 * ...
	 * @author Benn
	 */
	public class Player extends Entity 
	{
		
		[Embed(source="../assets/audio/jump.mp3")] private static const JUMP:Class;
		
		private var Jump:Sfx = new Sfx(JUMP);
		
		private const MoveSpeed : Number = 90;
		private const BonusSpeed : Number = 45;
		private const JumpHeight : Number = 2.5;
		private const Gravity : Number = -8.0;
		
		private var velocityY : Number = 0;
		private var OnPlatform : Boolean = false;
		private var currentPlatform : Platform = null;
		
		private var currentCircle : CircleWorld;
		
		//moving between worlds
		private var movementtween : QuadMotion;
		private var MovedOutOfBounds : Boolean = false;
		private var movingbetweenworlds : Boolean = false;
		private var movementcomplete : Boolean = false;
		
		//endgame
		private var movingFinal : Boolean = false;
		
		public function Player() 
		{
			
			x = 270;
			y = 0.5;
			
			movementtween = new QuadMotion(MoveBetweenWorldsComplete);
		}
		
		public function SetMovingFinal(): void
		{
			x = 302.5;
			y = -747.5;
			movingFinal = true;
		}
		
		public function GetOutOfBounds() : Boolean
		{
			return MovedOutOfBounds;
		}
		
		public function GetMovementComplete() : Boolean
		{
			return movementcomplete;
		}
		
		private function MoveBetweenWorldsComplete() : void
		{
			removeTween(movementtween);
			movementcomplete = true;
		}
		
		public function SetMoveBetweenWorlds( startx : int, starty : int, contx : int, conty: int, endx : int, endy : int ) : void
		{
			
			MovedOutOfBounds = false;
			movingbetweenworlds = true;
			
			movementtween.setMotion(startx, starty, contx, conty, endx, endy, 1.0);
			addTween(movementtween, true);	
			
		}
		
		public function GetMovingBetweenWorlds() : Boolean
		{
			return movingbetweenworlds;
		}
		
		public function Reset() : void
		{
			
			MovedOutOfBounds = false;
			movementcomplete = false;
			movingbetweenworlds = false;
			velocityY = 0;
			
			if (currentCircle.level == 1)
			{
				x = 270;
				y = 0.5;
			}
			if (currentCircle.level == 2)
			{
				y = 0.2;
				x = 180;
			}
			else if (currentCircle.level == 3)
			{
				y = 0.2;
				x = 270;
			}
			else if (currentCircle.level == 4)
			{
				y = 0.2;
				x = 90;
			}
			else if (currentCircle.level == 5)
			{
				y = 0.1;
				x = 0;
			}
			
		}
		
		public function SetCurrentCircle(value : CircleWorld):void
		{
			currentCircle = value;	
		}
		
		private function UpdateMoveBetweenWorlds():void
		{
			x = movementtween.x;
			y = movementtween.y;
		}
		
		private function UpdateCircleMovement():void
		{
			
			var PlatformArray : Array = currentCircle.GetPlatformArray();
			var P : Platform;
			
			var boundsleft : Number;
			var boundsright : Number;
			
			if (OnPlatform && currentPlatform)
			{
				
				if (currentPlatform.rotating == true)
				{
					x -= currentPlatform.rotatespeed * FP.elapsed;
				}
				
				if (x < 0)
				{
					x += 360;
				}
				
				for each (P in PlatformArray)
				{
					
					boundsleft = P.x - 6;
					boundsright = P.x + P.platwidth + 6;
					
					if (P.x + P.platwidth > 360)
					{
						
						boundsright -= 360;
						
						if ((x > boundsleft || x < boundsright) && y + 0.0001 > P.y && y + 0.0001 < P.y + 0.1)
						{
							x = boundsright + 7;
						}
						
					}
					else
					{
					
						if ((x > boundsleft && x < boundsright) && y + 0.0001 > P.y && y + 0.0001 < P.y + 0.1)
						{
							x = P.x + P.platwidth + 7;
						}
					
					}
					
				}	
				
			}
			
			if (Input.check(Key.A) || Input.check(Key.LEFT))
			{
				
				x -= (MoveSpeed + (BonusSpeed * y)) * FP.elapsed;
				
				if (x < 0)
				{
					x += 360;
				}
				
				for each (P in PlatformArray)
				{
					
					boundsleft = P.x - 6;
					boundsright = P.x + P.platwidth + 6;
					
					if (P.x + P.platwidth > 360)
					{
						
						boundsright -= 360;
						
						if ((x > boundsleft || x < boundsright) && y + 0.0001 > P.y && y + 0.0001 < P.y + 0.1)
						{
							x = boundsright + 7;
						}
						
					}
					else
					{
					
						if ((x > boundsleft && x < boundsright) && y + 0.0001 > P.y && y + 0.0001 < P.y + 0.1)
						{
							x = P.x + P.platwidth + 7;
						}
					
					}
					
				}	
				
			}
			else if (Input.check(Key.D) || Input.check(Key.RIGHT))
			{
				
				x += (MoveSpeed + (BonusSpeed * y)) * FP.elapsed;
				
				if (x > 360)
				{
					x -= 360;
				}
				
				for each (P in PlatformArray)
				{
					
					boundsleft = P.x - 6;
					boundsright = P.x + P.platwidth + 6;				
					
					if (boundsright > 360)
					{
						boundsright -= 360;
						
						if ((x > boundsleft || x < boundsright) && y + 0.0001 > P.y && y + 0.0001 < P.y + 0.1)
						{	
							x = boundsleft - 7;
						}
						
					}
					else if (boundsleft < 0)
					{
						boundsleft += 360;
						
						if ((x > boundsleft || x < boundsright) && y + 0.0001 > P.y && y + 0.0001 < P.y + 0.1)
						{	
							x = P.x - 7;
						}
						
					}
					else
					{
						if (x > boundsleft && x < boundsright && y + 0.0001 > P.y && y + 0.0001 < P.y + 0.1)
						{
							x = P.x - 7;
						}
					}
						
				}
				
			}
			
			if (x < 0)
			{
				x += 360;
			}
			else if (x > 360)
			{
				x -= 360;
			}
			
			if (OnPlatform)
			{
				
				if (Input.pressed(Key.W) || Input.pressed(Key.SPACE) || Input.pressed(Key.UP))
				{
					Jump.play();
					velocityY = JumpHeight;
					OnPlatform = false;
				}
				
				if (!currentPlatform)
				{
					OnPlatform = false;
				}
				else
				{

					if (currentPlatform.x + currentPlatform.platwidth > 360)
					{
						if (x < currentPlatform.x - 6 && x > currentPlatform.x + currentPlatform.platwidth - 360)
						{
							OnPlatform = false;
						}
					}
					else if (x < currentPlatform.x - 6 || x > currentPlatform.x + currentPlatform.platwidth + 6)
					{
						OnPlatform = false;
					}
					
				}
				
			}
			else
			{
				
				velocityY += Gravity * FP.elapsed;
				y += velocityY * FP.elapsed;
				
				if (velocityY > 0 && y > 1.0)
				{
					
					x += 180;
					
					if (x > 360)
					{
						x -= 360;
					}
					
					velocityY = -velocityY;
					
					y = 1.0 - (y - 1.0);
					
				}
				
				for each (P in PlatformArray)
				{
					
					if (velocityY > 0) //travelling upwards
					{
						
						boundsleft = P.x - 6;
						boundsright = P.x + P.platwidth + 6;
						
						if (boundsright > 360)
						{
							
							boundsright -= 360;			
							
							if ((x > boundsleft || x < boundsright) && y + 0.1001 > P.y && y + 0.1001 < P.y + 0.1)
							{	
								y = P.y - P.platheight;
								velocityY = 0;
							}
							
						}
						else if (boundsleft < 0)
						{
							
							boundsleft += 360;
							
							if ((x > boundsleft || x < boundsright) && y + 0.1001 > P.y && y + 0.1001 < P.y + 0.1)
							{	
								y = P.y - P.platheight;
								velocityY = 0;
							}
							
						}
						else
						{
							if (x > boundsleft && x < boundsright && y + 0.1001 > P.y && y + 0.1001 < P.y + 0.1)
							{
								y = P.y - P.platheight;	
								velocityY = 0;
							}
						}
						
					}
					else //travelling downwards
					{
						
						if (y < 0.0)
						{
							MovedOutOfBounds = true;
							return;
						}
						
						boundsleft = P.x - 6;
						boundsright = P.x + P.platwidth + 6;
						
						if (boundsright > 360)
						{
							
							boundsright -= 360;			
							
							if ((x > boundsleft || x < boundsright) && y + 0.0001 > P.y && y + 0.0001 < P.y + 0.1)
							{	
								velocityY = 0;
								OnPlatform = true;
								currentPlatform = P;
								y = P.y + P.platheight;
							}
							
						}
						else if (boundsleft < 0)
						{
							
							boundsleft += 360;		
							
							if ((x > boundsleft || x < boundsright) && y + 0.0001 > P.y && y + 0.0001 < P.y + 0.1)
							{	
								velocityY = 0;
								OnPlatform = true;
								currentPlatform = P;
								y = P.y + P.platheight;
							}
							
						}
						else
						{
							
							if (x > boundsleft && x < boundsright && y + 0.0001 > P.y && y < P.y + 0.1)
							{
								velocityY = 0;
								OnPlatform = true;
								currentPlatform = P;
								y = P.y + P.platheight;
							}
							
						}	
						
					}
					
				}
				
			}
		}
		
		override public function update():void 
		{
			
			if (movingFinal)
			{
				x -= 300 * FP.elapsed;
				return;
			}
			
			if (movementcomplete)
			{
				return;
			}
			
			if (movingbetweenworlds)
			{
				UpdateMoveBetweenWorlds();
			}
			else
			{
				UpdateCircleMovement();
			}
			
			
			super.update();
		}
		
	}

}